/**
 * Freqtrade API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2021.12-dev21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';
import Balance from './Balance';

/**
 * The Balances model module.
 * @module model/Balances
 * @version 2021.12-dev21
 */
class Balances {
    /**
     * Constructs a new <code>Balances</code>.
     * @alias module:model/Balances
     * @param currencies {Array.<module:model/Balance>} 
     * @param total {Number} 
     * @param symbol {String} 
     * @param value {Number} 
     * @param stake {String} 
     * @param note {String} 
     * @param startingCapital {Number} 
     * @param startingCapitalRatio {Number} 
     * @param startingCapitalPct {Number} 
     * @param startingCapitalFiat {Number} 
     * @param startingCapitalFiatRatio {Number} 
     * @param startingCapitalFiatPct {Number} 
     */
    constructor(currencies, total, symbol, value, stake, note, startingCapital, startingCapitalRatio, startingCapitalPct, startingCapitalFiat, startingCapitalFiatRatio, startingCapitalFiatPct) { 
        
        Balances.initialize(this, currencies, total, symbol, value, stake, note, startingCapital, startingCapitalRatio, startingCapitalPct, startingCapitalFiat, startingCapitalFiatRatio, startingCapitalFiatPct);
    }

    /**
     * Initializes the fields of this object.
     * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
     * Only for internal use.
     */
    static initialize(obj, currencies, total, symbol, value, stake, note, startingCapital, startingCapitalRatio, startingCapitalPct, startingCapitalFiat, startingCapitalFiatRatio, startingCapitalFiatPct) { 
        obj['currencies'] = currencies;
        obj['total'] = total;
        obj['symbol'] = symbol;
        obj['value'] = value;
        obj['stake'] = stake;
        obj['note'] = note;
        obj['starting_capital'] = startingCapital;
        obj['starting_capital_ratio'] = startingCapitalRatio;
        obj['starting_capital_pct'] = startingCapitalPct;
        obj['starting_capital_fiat'] = startingCapitalFiat;
        obj['starting_capital_fiat_ratio'] = startingCapitalFiatRatio;
        obj['starting_capital_fiat_pct'] = startingCapitalFiatPct;
    }

    /**
     * Constructs a <code>Balances</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/Balances} obj Optional instance to populate.
     * @return {module:model/Balances} The populated <code>Balances</code> instance.
     */
    static constructFromObject(data, obj) {
        if (data) {
            obj = obj || new Balances();

            if (data.hasOwnProperty('currencies')) {
                obj['currencies'] = ApiClient.convertToType(data['currencies'], [Balance]);
            }
            if (data.hasOwnProperty('total')) {
                obj['total'] = ApiClient.convertToType(data['total'], 'Number');
            }
            if (data.hasOwnProperty('symbol')) {
                obj['symbol'] = ApiClient.convertToType(data['symbol'], 'String');
            }
            if (data.hasOwnProperty('value')) {
                obj['value'] = ApiClient.convertToType(data['value'], 'Number');
            }
            if (data.hasOwnProperty('stake')) {
                obj['stake'] = ApiClient.convertToType(data['stake'], 'String');
            }
            if (data.hasOwnProperty('note')) {
                obj['note'] = ApiClient.convertToType(data['note'], 'String');
            }
            if (data.hasOwnProperty('starting_capital')) {
                obj['starting_capital'] = ApiClient.convertToType(data['starting_capital'], 'Number');
            }
            if (data.hasOwnProperty('starting_capital_ratio')) {
                obj['starting_capital_ratio'] = ApiClient.convertToType(data['starting_capital_ratio'], 'Number');
            }
            if (data.hasOwnProperty('starting_capital_pct')) {
                obj['starting_capital_pct'] = ApiClient.convertToType(data['starting_capital_pct'], 'Number');
            }
            if (data.hasOwnProperty('starting_capital_fiat')) {
                obj['starting_capital_fiat'] = ApiClient.convertToType(data['starting_capital_fiat'], 'Number');
            }
            if (data.hasOwnProperty('starting_capital_fiat_ratio')) {
                obj['starting_capital_fiat_ratio'] = ApiClient.convertToType(data['starting_capital_fiat_ratio'], 'Number');
            }
            if (data.hasOwnProperty('starting_capital_fiat_pct')) {
                obj['starting_capital_fiat_pct'] = ApiClient.convertToType(data['starting_capital_fiat_pct'], 'Number');
            }
        }
        return obj;
    }


}

/**
 * @member {Array.<module:model/Balance>} currencies
 */
Balances.prototype['currencies'] = undefined;

/**
 * @member {Number} total
 */
Balances.prototype['total'] = undefined;

/**
 * @member {String} symbol
 */
Balances.prototype['symbol'] = undefined;

/**
 * @member {Number} value
 */
Balances.prototype['value'] = undefined;

/**
 * @member {String} stake
 */
Balances.prototype['stake'] = undefined;

/**
 * @member {String} note
 */
Balances.prototype['note'] = undefined;

/**
 * @member {Number} starting_capital
 */
Balances.prototype['starting_capital'] = undefined;

/**
 * @member {Number} starting_capital_ratio
 */
Balances.prototype['starting_capital_ratio'] = undefined;

/**
 * @member {Number} starting_capital_pct
 */
Balances.prototype['starting_capital_pct'] = undefined;

/**
 * @member {Number} starting_capital_fiat
 */
Balances.prototype['starting_capital_fiat'] = undefined;

/**
 * @member {Number} starting_capital_fiat_ratio
 */
Balances.prototype['starting_capital_fiat_ratio'] = undefined;

/**
 * @member {Number} starting_capital_fiat_pct
 */
Balances.prototype['starting_capital_fiat_pct'] = undefined;






export default Balances;

